"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */
var Avatar = function Avatar(_ref) {
  var _classNames;

  var className = _ref.className,
      imageUrl = _ref.imageUrl,
      isEmulating = _ref.isEmulating,
      size = _ref.size,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["className", "imageUrl", "isEmulating", "size", "testSection"]);

  var avatarClassNames = (0, _classnames["default"])("oui-avatar", (_classNames = {}, _defineProperty(_classNames, "oui-avatar--".concat(size), size), _defineProperty(_classNames, "color-admin--border", isEmulating), _classNames), className);
  var avatarInlineStyles = imageUrl ? {
    backgroundImage: "url(".concat(imageUrl, ")")
  } : {};
  return _react["default"].createElement("div", {
    "data-test-section": testSection
  }, _react["default"].createElement("div", _extends({
    className: avatarClassNames,
    style: avatarInlineStyles
  }, props)));
};

Avatar.propTypes = {
  /**
   * CSS class names.
   */
  className: _propTypes["default"].string,

  /**
   * Image to use for the avatar - default is the anonymous head
   */
  imageUrl: _propTypes["default"].string,

  /**
   * Whether or not the emulating border should appear
   */
  isEmulating: _propTypes["default"].bool,

  /**
   * Size of the avatar, large is default
   */
  size: _propTypes["default"].oneOf(["small", "medium"]),

  /**
   * Data test section to use for testing
   */
  testSection: _propTypes["default"].string
};
var _default = Avatar;
exports["default"] = _default;