"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Row = function Row(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isFullWidth = _ref.isFullWidth,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["children", "className", "isFullWidth", "testSection"]);

  var mappedChildren = children.map(function (child, idx) {
    var rowClassname = (0, _classnames["default"])({
      "flex--1": isFullWidth,
      "push-double--right": idx < children.length - 1
    });
    return _react["default"].createElement("div", {
      key: idx,
      className: rowClassname
    }, child);
  });
  return _react["default"].createElement("div", _extends({
    "data-test-section": testSection,
    className: (0, _classnames["default"])("flex", className)
  }, props), mappedChildren);
};

Row.propTypes = {
  children: _propTypes["default"].node.isRequired,

  /** CSS class names. */
  className: _propTypes["default"].string,

  /** Indicates whether items in the row should take up as much width as possible */
  isFullWidth: _propTypes["default"].bool,
  testSection: _propTypes["default"].string
};
var _default = Row;
exports["default"] = _default;