"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _OverlayWrapper = _interopRequireDefault(require("../OverlayWrapper"));

var _Popover = _interopRequireDefault(require("../Popover"));

var _reactOuiIcons = _interopRequireDefault(require("react-oui-icons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HelpPopover = function HelpPopover(_ref) {
  var behavior = _ref.behavior,
      children = _ref.children,
      className = _ref.className,
      horizontalAttachment = _ref.horizontalAttachment,
      iconSize = _ref.iconSize,
      isConstrainedToScreen = _ref.isConstrainedToScreen,
      popoverTitle = _ref.popoverTitle,
      verticalAttachment = _ref.verticalAttachment,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["behavior", "children", "className", "horizontalAttachment", "iconSize", "isConstrainedToScreen", "popoverTitle", "verticalAttachment", "testSection"]);

  return _react["default"].createElement(_OverlayWrapper["default"], _extends({
    behavior: behavior,
    className: className,
    horizontalAttachment: horizontalAttachment,
    isConstrainedToScreen: isConstrainedToScreen,
    overlay: _react["default"].createElement(_Popover["default"], {
      title: popoverTitle
    }, children),
    testSection: testSection,
    verticalAttachment: verticalAttachment
  }, props), _react["default"].createElement("span", {
    className: "cursor--pointer push-half--left",
    "data-test-section": "help-popover-icon"
  }, _react["default"].createElement(_reactOuiIcons["default"], {
    name: "help",
    size: iconSize
  })));
};

HelpPopover.propTypes = {
  /** Event to listen to and open the overlay */
  behavior: _propTypes["default"].oneOf(["click", "hover"]),

  /** Description of thing that the person hovered for. */
  children: _propTypes["default"].node.isRequired,

  /** CSS class names. */
  className: _propTypes["default"].string,

  /** Side of the `overlay` that should attach to the `children` */
  horizontalAttachment: _propTypes["default"].oneOf(["left", "center", "right"]),

  /** Size of icon */
  iconSize: _propTypes["default"].oneOf(["small", "medium", "large"]),

  /** Attach `overlay` to an edge of the screen if it is going to move off */
  isConstrainedToScreen: _propTypes["default"].bool,

  /** Title of thing that is being described. */
  popoverTitle: _propTypes["default"].string,

  /** Test section */
  testSection: _propTypes["default"].string,

  /** Vertical edge of the `overlay` that should touch the `children` */
  verticalAttachment: _propTypes["default"].oneOf(["top", "middle", "bottom"])
};
HelpPopover.defaultProps = {
  behavior: "click",
  iconSize: "medium",
  isConstrainedToScreen: true,
  testSection: "help-popover"
};
var _default = HelpPopover;
exports["default"] = _default;