"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Wraps text or HTML in a `label` element. Often used to label inputs.
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */
var Label = function Label(_ref) {
  var children = _ref.children,
      className = _ref.className,
      inputId = _ref.inputId,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["children", "className", "inputId", "isOptional", "isRequired", "testSection"]);

  var classes = null;
  var fieldLabel = null;

  if (isRequired) {
    fieldLabel = _react["default"].createElement("span", {
      className: "oui-label--required"
    });
  } else if (isOptional) {
    fieldLabel = _react["default"].createElement("span", {
      className: "oui-label__optional"
    }, "(Optional)");
  }

  if (typeof children === "string") {
    classes = "oui-label";
  }

  return _react["default"].createElement("label", _extends({
    "data-oui-component": true,
    className: (0, _classnames["default"])(classes, className),
    "data-test-section": testSection,
    htmlFor: inputId
  }, props), children, fieldLabel);
};

Label.propTypes = {
  /** What the label describes */
  children: _propTypes["default"].oneOfType([_propTypes["default"].string.isRequired, _propTypes["default"].node.isRequired]),

  /** CSS class names. */
  className: _propTypes["default"].string,

  /** Id of the input to properly associate with this label */
  inputId: _propTypes["default"].string,

  /** Includes optional label if true */
  isOptional: _propTypes["default"].bool,

  /** Includes required asterisk label if true */
  isRequired: _propTypes["default"].bool,

  /** Hook for automated JavaScript tests */
  testSection: _propTypes["default"].string
};
var _default = Label;
exports["default"] = _default;