"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HeaderDetails = function HeaderDetails(_ref) {
  var className = _ref.className,
      items = _ref.items,
      spaceBelow = _ref.spaceBelow,
      props = _objectWithoutProperties(_ref, ["className", "items", "spaceBelow"]);

  var itemList = items.map(function (item, ind) {
    if (item.isVisible !== undefined && !item.isVisible) {
      return null;
    }

    return [_react["default"].createElement("div", {
      key: "label-".concat(item.label),
      className: (0, _classnames["default"])({
        sidenav__details__title: true,
        muted: true,
        "flush--bottom": true,
        "push--top": ind > 0
      })
    }, _react["default"].createElement("h5", null, item.label)), _react["default"].createElement("span", {
      key: "value-".concat(item.label),
      className: "sidenav__details__item"
    }, item.value)];
  });
  return _react["default"].createElement("div", _extends({
    className: (0, _classnames["default"])({
      sidenav__details: true,
      "soft-double--bottom": spaceBelow
    }, className)
  }, props), itemList);
};

HeaderDetails.propTypes = {
  /** CSS class names. */
  className: _propTypes["default"].string,

  /** List of details to display */
  items: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].node]).isRequired
  })).isRequired,

  /** Whether or not the details have extra space below */
  spaceBelow: _propTypes["default"].bool
};
HeaderDetails.defaultProps = {
  spaceBelow: false
};
var _default = HeaderDetails;
exports["default"] = _default;