"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var NavItem = function NavItem(_ref) {
  var className = _ref.className,
      isActive = _ref.isActive,
      leftContent = _ref.leftContent,
      rightContent = _ref.rightContent,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["className", "isActive", "leftContent", "rightContent", "testSection"]);

  return _react["default"].createElement("li", _extends({
    className: (0, _classnames["default"])({
      "nav-list__link": true,
      "is-active": isActive
    }, className),
    "data-test-section": testSection
  }, props), _react["default"].createElement("div", {
    className: "flex flex-justified--between flex-align--center flex--1 height--1-1"
  }, leftContent, rightContent && _react["default"].createElement("div", {
    className: "soft--right"
  }, rightContent)));
};

NavItem.propTypes = {
  /** CSS class names. */
  className: _propTypes["default"].string,

  /** Whether or not this item is currently selected */
  isActive: _propTypes["default"].bool,

  /**
   * Content to render within the NavItem
   * Will be left aligned
   */
  leftContent: _propTypes["default"].node.isRequired,

  /**
   * Content to render within the NavItem
   * Will be right aligned
   */
  rightContent: _propTypes["default"].node,

  /** String to use for testing */
  testSection: _propTypes["default"].string
};
var _default = NavItem;
exports["default"] = _default;