"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */
var Switch = function Switch(_ref) {
  var ariaLabel = _ref.ariaLabel,
      checked = _ref.checked,
      className = _ref.className,
      _ref$elementId = _ref.elementId,
      elementId = _ref$elementId === void 0 ? "switch1" : _ref$elementId,
      isDisabled = _ref.isDisabled,
      onClick = _ref.onClick,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["ariaLabel", "checked", "className", "elementId", "isDisabled", "onClick", "testSection"]);

  var switchClasses = (0, _classnames["default"])({
    "oui-switch": true,
    "oui-switch--disabled": isDisabled
  }, className);
  return _react["default"].createElement("div", {
    className: "position--relative flex flex-align--center",
    "data-oui-component": true,
    "data-test-section": testSection
  }, _react["default"].createElement("input", _extends({
    "aria-label": ariaLabel,
    type: "checkbox",
    id: elementId,
    className: switchClasses,
    checked: checked,
    onClick: onClick,
    disabled: isDisabled
  }, props)), _react["default"].createElement("label", {
    htmlFor: elementId,
    "data-on-label": "On",
    "data-off-label": "Off"
  }));
};

Switch.propTypes = {
  /**
   * Hidden label to describe this switch
   * Must be used when no clear associated context
   * is available in the UI.
   */
  ariaLabel: _propTypes["default"].string,
  // checked true means the switch is on; false is off
  checked: _propTypes["default"].bool,

  /** CSS class names. */
  className: _propTypes["default"].string,
  // string for label/input id pair, should be unique to the page
  elementId: _propTypes["default"].string.isRequired,

  /** Whether it is disabled, will render greyscale if so **/
  isDisabled: _propTypes["default"].bool,
  // onClick function
  onClick: _propTypes["default"].func,

  /** Hook for automated JavaScript tests */
  testSection: _propTypes["default"].string
};
var _default = Switch;
exports["default"] = _default;