function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import PropTypes from "prop-types";
import classNames from "classnames";
/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */

var Category = function Category(_ref) {
  var children = _ref.children,
      className = _ref.className,
      header = _ref.header,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["children", "className", "header", "testSection"]);

  return React.createElement("li", _extends({
    className: classNames("oui-block-list__category", className),
    "data-test-section": testSection
  }, props), header && React.createElement("div", {
    className: "oui-block-list__category__name soft-half--ends soft--sides",
    style: {
      wordBreak: "break-word"
    }
  }, header), children && React.createElement("ul", null, children));
};

Category.propTypes = {
  /** Items that appears within the category */
  children: PropTypes.node.isRequired,

  /** CSS class names. */
  className: PropTypes.string,

  /** Node or component that appears above the `children` */
  header: PropTypes.node,

  /** Hook for automated JavaScript tests */
  testSection: PropTypes.string
};
Category.displayName = "BlockList.Category";
export default Category;