function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import PropTypes from "prop-types";
import classNames from "classnames";
import Header from "./Header";
import NavList from "./NavList";
import NavItem from "./NavItem";
import HeaderDetails from "./HeaderDetails";

var ManagerSideNav = function ManagerSideNav(_ref) {
  var children = _ref.children,
      className = _ref.className,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["children", "className", "testSection"]);

  var renderChildrenByType = function renderChildrenByType(ComponentType) {
    return React.Children.toArray(children).filter(function (child) {
      return child.type === ComponentType;
    }).map(function (element) {
      return React.cloneElement(element);
    });
  };

  return React.createElement("div", _extends({
    "data-ui-component": true,
    "data-test-section": testSection,
    className: classNames("oui-manager-side-nav stage__item__content--column", className)
  }, props), renderChildrenByType(Header), React.createElement("div", {
    className: "sidenav__body"
  }, renderChildrenByType(NavList)));
};

ManagerSideNav.propTypes = {
  // eslint-disable-next-line valid-jsdoc

  /* Allowed children are ManagerSideNav's Header and NavList*/
  children: function children(props, propName) {
    var prop = props[propName];
    var error = null;
    React.Children.forEach(prop, function (child) {
      if (child === null) {
        return;
      }

      if (![Header, NavList].includes(child.type)) {
        error = new Error("Children of ManagerSideNav should be of type Header or NavList.");
      }
    });
    return error;
  },

  /** CSS class names. */
  className: PropTypes.string,

  /** Value used for testing via data-test-section attribute */
  testSection: PropTypes.string
};
ManagerSideNav.defaultProps = {
  testSection: ""
};
ManagerSideNav.Header = Header;
ManagerSideNav.HeaderDetails = HeaderDetails;
ManagerSideNav.NavList = NavList;
ManagerSideNav.NavItem = NavItem;
export default ManagerSideNav;