function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import PropTypes from "prop-types";
import classNames from "classnames";
/**
 * Generates an `spinner` element with/without overlay and optinaly
 * using props for sizes small or tiny for smaller sizes.
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */

var Spinner = function Spinner(_ref) {
  var className = _ref.className,
      hasOverlay = _ref.hasOverlay,
      size = _ref.size,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["className", "hasOverlay", "size", "testSection"]);

  var classes = classNames("oui-spinner", _defineProperty({}, "oui-spinner--".concat(size), size));

  if (hasOverlay) {
    return React.createElement("div", _extends({
      "data-oui-component": true,
      "data-test-section": testSection,
      className: classNames("oui-overlay", className)
    }, props), React.createElement("div", {
      className: classes
    }));
  }

  return React.createElement("div", _extends({
    "data-test-section": testSection,
    className: classNames(classes, className)
  }, props));
};

Spinner.propTypes = {
  /** CSS class names. */
  className: PropTypes.string,

  /** boolean class for establish overlay */
  hasOverlay: PropTypes.bool,

  /** various sizes */
  size: PropTypes.oneOf(["small", "tiny"]),

  /** Hook for automated JavaScript tests */
  testSection: PropTypes.string
};
Spinner.displayName = "Spinner";
export default Spinner;