function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import PropTypes from "prop-types";
import classNames from "classnames";
import THead from "./THead";
import TR from "./TR";
import TH from "./TH";
import TBody from "./TBody";
import TD from "./TD";
/**
 * Simple component to wrap `Table.THead` and `Table.TBody` components.
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */

var Table = function Table(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      density = _ref.density,
      shouldAddHover = _ref.shouldAddHover,
      style = _ref.style,
      tableLayoutAlgorithm = _ref.tableLayoutAlgorithm,
      testSection = _ref.testSection,
      props = _objectWithoutProperties(_ref, ["children", "className", "density", "shouldAddHover", "style", "tableLayoutAlgorithm", "testSection"]);

  var classes = classNames((_classNames = {
    "oui-table": true
  }, _defineProperty(_classNames, "oui-table--".concat(style), style), _defineProperty(_classNames, "oui-table--".concat(density), density), _defineProperty(_classNames, "oui-table--hover", shouldAddHover), _classNames), className);
  var styles = {
    tableLayout: tableLayoutAlgorithm
  };
  return React.createElement("table", _extends({
    "data-oui-component": true,
    className: classes,
    style: styles,
    "data-test-section": testSection
  }, props), children);
};

Table.propTypes = {
  /** Should be a `Table.THead` or `Table.TBody` */
  children: PropTypes.node,

  /** CSS class names. */
  className: PropTypes.string,

  /** Sets the padding within cells */
  density: PropTypes.oneOf(["tight", "loose"]),

  /** Whether to set the hover class on the Table */
  shouldAddHover: PropTypes.bool,

  /** Available border and hover options */
  style: PropTypes.oneOf(["wall", "rule", "rule-no-bottom-border"]),

  /**
  Adjust the [CSS `table-layout` property](https://developer.mozilla.org/en-US/docs/Web/CSS/table-layout)
  that is used to calculate the with of inner table cells.
  */
  tableLayoutAlgorithm: PropTypes.oneOf(["auto", "fixed"]),

  /** Hook for automated JavaScript tests */
  testSection: PropTypes.string
};
Table.defaultProps = {
  density: "tight",
  tableLayoutAlgorithm: "fixed"
};
Table.THead = THead;
Table.TR = TR;
Table.TH = TH;
Table.TBody = TBody;
Table.TD = TD;
export default Table;