function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import PropTypes from "prop-types";
import React from "react";
import classNames from "classnames";
import ToolbarButton from "./ToolbarButton";
import ToolbarLink from "./ToolbarLink";

var Left = function Left(props) {
  return React.createElement("div", {
    className: "toolbar__left"
  }, props.children);
};

Left.propTypes = {
  children: PropTypes.node.isRequired
};

var Right = function Right(props) {
  return React.createElement("div", {
    className: "toolbar__right"
  }, props.children);
};

Right.propTypes = {
  children: PropTypes.node.isRequired
};
/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */

var Toolbar = function Toolbar(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isBottomToolbar = _ref.isBottomToolbar,
      testSection = _ref.testSection,
      toolbarStyle = _ref.toolbarStyle,
      props = _objectWithoutProperties(_ref, ["children", "className", "isBottomToolbar", "testSection", "toolbarStyle"]);

  var toolbarContentClasses = classNames({
    toolbar__content: true,
    "toolbar__content--bare": toolbarStyle.includes("bare"),
    "toolbar__content--tight": toolbarStyle.includes("tight"),
    "background--white": isBottomToolbar,
    "border--top": isBottomToolbar,
    "no-border--bottom": isBottomToolbar || toolbarStyle.includes("bare"),
    "hard--left": isBottomToolbar
  }, className);
  return React.createElement("div", _extends({
    "data-oui-component": true,
    className: classNames("toolbar", className),
    "data-test-section": testSection
  }, props), React.createElement("div", {
    className: toolbarContentClasses
  }, children));
};

Toolbar.defaultProps = {
  isBottomToolbar: false,
  toolbarStyle: []
};
Toolbar.propTypes = {
  /** Items to render for the toolbar */
  children: PropTypes.node.isRequired,

  /** CSS class names. */
  className: PropTypes.string,

  /** Whether this toolbar sits at the bottom of a page */
  isBottomToolbar: PropTypes.bool,

  /** Hook to uze for automated testing */
  testSection: PropTypes.string,

  /** The style to use for this toolbar */
  toolbarStyle: PropTypes.arrayOf(PropTypes.oneOf(["bare", "tight"]))
};
Toolbar.Button = ToolbarButton;
Toolbar.Link = ToolbarLink;
Toolbar.Right = Right;
Toolbar.Left = Left;
export default Toolbar;